/////////////////////////////////////////////////////////////////////
//Aufgabe 5b aus Kapitel Bibliotheken
////////////////////////////////////////////////////////////////

import toxi.physics2d.*;
import toxi.physics2d.behaviors.*;
import toxi.geom.*;


VerletPhysics2D physics;
AttractionBehavior2D mouseAttractor;
AttractionBehavior2D zufallAttractor;
int i =0;
float laenge  = 75;//Federlänge
int anzahlMassen =6;
float fHaerte = 1.9;//Federhärte
Vec2D mausPos, zufallPos;
boolean kraftZeichnen = false;
VerletConstrainedSpring2D [] feder = new VerletConstrainedSpring2D[anzahlMassen];
Masse [] m = new Masse[anzahlMassen+1] ;

void setup(){
  size(1000, 1000);
  background(0);
 
  //Massenpunkte initialisieren
  m[0] = new Masse(new Vec2D(width/2, height/2),0,3,color(0));//Aufhängnung
  m[0].lock();
  for(int i =1;i<=anzahlMassen;i++){
    m[i]= new Masse(new Vec2D(width/2+random(3),height/2-i*laenge),1,5,color(random(255),random(255),random(255)));
  }
  
  //Federstücke initialisieren
  for(int i =0;i<anzahlMassen;i++){
    feder[i]= new VerletConstrainedSpring2D(m[i], m[i+1], laenge, fHaerte, laenge);
  }
 
  physics = new VerletPhysics2D();
  //World Setup and additions
  physics.setWorldBounds(new Rect(0, 0, width, height));
  physics.addBehavior(new GravityBehavior2D(new Vec2D(0, 0.05)));//(0,0.05)
  
  //Massenpunkte und federstücke in die Welt bringen
  for(int i =0;i<anzahlMassen+1;i++){
    physics.addParticle(m[i]);
  }
  for(int i =0;i<anzahlMassen;i++){
     physics.addSpring(feder[i]);
  }
}

void draw(){
//Positionen aller Massenpunkte und Federn im Laufe der Zeit
   if(mousePressed){
    fill(240);
    ellipse(mausPos.x,mausPos.y,10,10);  
  }
  physics.update();
 
  for(int i=0;i<=anzahlMassen; i++){
    m[i].display();
  }
}

void mousePressed(){
   mausPos = new Vec2D(mouseX, mouseY);
   // Kraftfeld an mausPos mit Stärke 0.5 und Wirkweite 1000
   mouseAttractor = new AttractionBehavior2D(mausPos, 1000, 0.5);
   physics.addBehavior(mouseAttractor);
}

void mouseReleased() {
  // Kraftfeld entfernen
  physics.removeBehavior(mouseAttractor);
}

void keyPressed(){
  if(key=='s'){
   saveFrame("PendelPunkte.jpg");
  }
}